use core::ffi::c_void;

unsafe extern "C" {
    fn algorithms_c_is_loaded() -> bool;
}

pub fn ffi_is_loaded() -> bool {
    unsafe { algorithms_c_is_loaded() }
}

#[inline]
pub(crate) fn ref_to_voidptr<T: ?Sized>(r: &T) -> *const c_void {
    r as *const T as *const c_void
}

#[cfg(test)]
mod test {
    use crate::ffi_is_loaded;

    #[test]
    fn test_ffi_loaded() {
        assert!(ffi_is_loaded())
    }
}
